
#ifndef CAMERA_H
#define CAMERA_H

#include "common.h"


class Camera {
public:
   Camera(): pos(0.0, 0.0, 0.0), xRot(0.0), yRot(0.0), zRot(0.0) { }

  // methods to access camera's orientation
  inline float getXRot() const { return xRot; }
  inline float getYRot() const { return yRot; }
  inline float getZRot() const { return zRot; }
  //Quat getQuat() const;

  // returns camera's position
  inline const Point3& getPos() const { return pos; }

  // sets camera's position
  inline void setPos(const Point3& p) { pos = p; }

  // updates camera's position
  inline void updatePos(const Vector3& v) { pos = pos + v; }

  // methods to change orientation
  inline void updateXRot(float dtheta) { xRot += dtheta; }
  inline void updateYRot(float dtheta) { yRot += dtheta; }
  inline void updateZRot(float dtheta) { zRot += dtheta; }

  inline void setXRot(float theta) { xRot = theta; }
  inline void setYRot(float theta) { yRot = theta; }
  inline void setZRot(float theta) { zRot = theta; }

private:
   // camera position
   Point3 pos;

   // camera orientation represented by euler angles
   float xRot, yRot, zRot;
};


#endif
