
#ifndef LISTSCENE_H
#define LISTSCENE_H

#include <vector>
#include "common.h"
#include "Scene.h"


class ListScene : public Scene {
public:
  virtual ~ListScene();

  virtual void insertObject(SceneObject *);

  virtual void insertLight(const Light &light);

  virtual SceneObject *findNearestHit(const Ray &ray,
                                      HitInfo &hitInfoOut);
                                      
  virtual bool occlusionTest(const Ray &ray, float maxT) const;

  virtual const std::vector<Light>& getLights() const
     { return lights; } // TODO: get rid of this

  virtual RGBColor<float> lightContrib(const Ray &ray,
                                       const Point3 &pos,
                                       const Vector3 &n,
                                       int matID,
                                       const Point2 &tc);
private:
  std::vector<SceneObject *> sceneObjects;
  std::vector<Light> lights;
};


#endif
