
#ifndef MATERIAL_H
#define MATERIAL_H

#include "RGBColor.h"
#include "Texture2D.h"


class Material {
public:
  Material():
       ambient(0.0f, 0.0f, 0.0f),
       diffuse(0.0f, 0.0f, 0.0f),
       specular(0.0f, 0.0f, 0.0f),
       shininess(0.0f),
       reflectivity(0.0f),
       refrIndex(0.0f),
       texture(NULL),
       normalMap(NULL) { }
  RGBColor<float> ambient,
                  diffuse,
                  specular;

  float shininess,
        reflectivity,
        refrIndex;
  Texture2D *texture;   // these textures are not deleted by the Material class
  Texture2D *normalMap; // so they must be deleted where they are stored
                        // (currently in the Scene class)
};

#endif
