
#include <cmath>
#include <cstddef>

namespace Math3D {

// for this project I've taken everything out of this
// file except for this one function (I probably should just
// take the whole file out)

// returns true if ray intersects sphere and stores t of intersection
template<class Real>
bool intersectRaySphere(const Ray<Real> &ray, const Point3<Real> &pos,
                        Real radius, Real *t0, Real *t1) {
  // compute vector from ray origin to center of sphere
  Vector3<Real> e = pos - ray.getOrigin();

  // project e onto direction vector of ray
  Real a = e*ray.getDir();

  Real bSqr = e*e - a*a;   

  if ( bSqr > radius*radius )
    return false;

  Real f = rsqrt(radius*radius - bSqr);

  if ( t0 != NULL )
    (*t0) = a - f;
  if ( t1 != NULL )
    (*t1) = a + f;

  return true;
}


} // namespace Math3D
