
#ifndef RGBColor_H
#define RGBColor_H


template<class Real>
class RGBColor {
public:
  inline RGBColor() { }
  inline RGBColor(Real r, Real g, Real b) {
    c[0] = r;
    c[1] = g;
    c[2] = b;
  }

  inline const RGBColor<Real>& operator += (const RGBColor<Real> &rhs) {
    c[0] += rhs.c[0];
    c[1] += rhs.c[1];
    c[2] += rhs.c[2];
    return (*this);
  }

  inline const RGBColor<Real>& operator *= (const RGBColor<Real> &rhs) {
    c[0] *= rhs.c[0];
    c[1] *= rhs.c[1];
    c[2] *= rhs.c[2];
    return (*this);
  }

  inline RGBColor<Real> operator * (Real s) const {
    return RGBColor<Real>(c[0]*s, c[1]*s, c[2]*s);
  }

  inline RGBColor<Real> operator * (const RGBColor<Real> &rhs) const {
   return RGBColor<Real>(c[0]*rhs.c[0], c[1]*rhs.c[1], c[2]*rhs.c[2]);
  }

  inline RGBColor<Real> operator + (const RGBColor<Real> &rhs) const {
    return RGBColor<Real>(c[0]+rhs.c[0], c[1]+rhs.c[1], c[2]+rhs.c[2]);
  }

  inline Real& operator [] (int i) {
    // no bounds check for the sake of speed
    return c[i];
  }

  inline void clamp(Real lower, Real upper) {
    for ( int i=0; i < 3; i++ ) {
      if ( c[i] > upper )
        c[i] = upper;
      if ( c[i] < lower )
        c[i] = lower;
    }
  }

  Real c[3];
};

#endif

