
#ifndef RAYTRACERAPP_H
#define RAYTRACERAPP_H

#include "RayTracer.h"
#include "Scene.h"


class RayTracerApp {
public:
  RayTracerApp(int argc, char *argv[]);
  ~RayTracerApp();

  int exec();
private:
  bool parseArgs(int argc, char *argv[],
                 int &screenWidth, int &screenHeight,
                 int &numThreads, bool &fullscreen);
  void printHelp(const char *cmd);
  void initVideo(int screenWidth, int screenHeight, bool fullscreen);
  void initScene();
  void showImage();
  void mainLoop();
  void handleKeyboard(float dt);
  void handleMouseMotion(float dt);

  static const float moveSpeed,
                     mouseSensitivity;

  bool initialized;
  bool controlEnabled;
  RayTracer *rayTracer;
  Scene *scene;
  SDL_Surface *displaySurface;
};


#endif
