
#ifndef SPHEREOBJECT_H
#define SPHEREOBJECT_H

#include "SceneObject.h"


class SphereObject : public SceneObject {
public:
  SphereObject(const Point3 &p, float r, int mat);

  virtual bool intersectRay(const Ray &ray,
                            HitInfo &hitInfo) const;
                            
  virtual bool occlusionTest(const Ray &ray,
                             float maxT) const;

  virtual int getMatID() const { return matID; }

  virtual void getNormalAndTCAt(const Point3 &p,
                                int texInfo,
                                const Material &mat,
                                Point2 &tc,
                                Vector3 &normal) const;

  virtual AABB getAABB() const;
private:
  Point3 pos;       // position
  float radius;     // radius of sphere
  int matID;        // material ID
};


#endif
