
#ifndef TEXTURE2D_H
#define TEXTURE2D_H

#include "RGBColor.h"
#include "TGAFile.h"


// storage of uncompressed 2D texture
// (currently only supporting RGB)
class Texture2D {
public:
  Texture2D();
  Texture2D(const TGAFile &tga);
  ~Texture2D();

  RGBColor<float> sample(float u, float v) const;
  RGBColor<float> sampleBilinear(float u, float v) const;

private: 
  int width, height;        // dimensions
  float fWidth, fHeight;   // dimensions as floats
  RGBColor<float> *image;    // image data
}; // Texture2D


#endif
